module ynu_ti_aescore
(
 clk_in
,en_mk_in
,en_ek_in
,en_dr_in
,en_o_in
,sel_ek_in
,sel_rcon_in
,sel_i_in
,sel_f_in
,data_in
,key_in
,rk1_in
,rk2_in
,rk3_in
,rk4_in
,rd1_in
,rd2_in
,rd3_in
,rd4_in
,data_out
);

input           clk_in;
input           en_mk_in;
input           en_ek_in;
input           en_dr_in;
input           en_o_in;
input           sel_ek_in;
input   [3:0]   sel_rcon_in;
input           sel_i_in;
input           sel_f_in;
input   [127:0] data_in;
input   [127:0] key_in;
input   [127:0] rk1_in,rk2_in,rk3_in,rk4_in;
input   [127:0] rd1_in,rd2_in,rd3_in,rd4_in;
output  [127:0] data_out;

wire    [127:0] k1_w,k2_w,k3_w,k4_w;

ynu_ti_kecore   U_KECORE
(
 .clk_in        ( clk_in        )
,.en_mk_in      ( en_mk_in      )
,.en_ek_in      ( en_ek_in      )
,.sel_ek_in     ( sel_ek_in     )
,.sel_rcon_in   ( sel_rcon_in   )
,.mk_in         ( key_in        )
,.rk1_in        ( rk1_in        )
,.rk2_in        ( rk2_in        )
,.rk3_in        ( rk3_in        )
,.rk4_in        ( rk4_in        )
,.k1_out        ( k1_w          )
,.k2_out        ( k2_w          )
,.k3_out        ( k3_w          )
,.k4_out        ( k4_w          )
);

ynu_ti_enccore  U_ENCCORE
(
 .clk_in    ( clk_in    )
,.en_dr_in  ( en_dr_in  )
,.en_o_in   ( en_o_in   )
,.sel_i_in  ( sel_i_in  )
,.sel_f_in  ( sel_f_in  )
,.d_in      ( data_in   )
,.k1_in     ( k1_w      )
,.k2_in     ( k2_w      )
,.k3_in     ( k3_w      )
,.k4_in     ( k4_w      )
,.rd1_in    ( rd1_in    )
,.rd2_in    ( rd2_in    )
,.rd3_in    ( rd3_in    )
,.rd4_in    ( rd4_in    )
,.d_out     ( data_out  )
);


endmodule
