module ynu_ti_aesctl
(
 clk_in
,rst_n_in
,en_key_in
,en_data_in
,cnt_out
,end_cal_out
,en_core_out
,en_key_out
,en_data_out
,busy_out
);


input           clk_in;
input           rst_n_in;
input           en_key_in;
input           en_data_in;
output  [3:0]   cnt_out;
output          end_cal_out;
output          en_core_out;
output          en_key_out;
output          en_data_out;
output          busy_out;


reg             busy_r;
reg     [3:0]   cnt_r;
reg             en_key_r;
reg             end_cnt_r;
wire            end_cnt_w;


always @(posedge clk_in or negedge rst_n_in)
begin
    if(rst_n_in==1'b0)
        busy_r <= 1'b0;
    else
        begin
            if(en_data_in==1'b1)
                busy_r <= 1'b1;
            else if(end_cnt_w==1'b1)
                busy_r <= 1'b0;
            else
                busy_r <= busy_r;
        end
end

always @(posedge clk_in or negedge rst_n_in)
begin
    if(rst_n_in==1'b0)
        cnt_r <= 4'h0;
    else
        begin
            if(en_data_in==1'b1)
                cnt_r <= 4'h0;
            else if(busy_r==1'b1)
                cnt_r <= cnt_r + 1'b1;
            else
                cnt_r <= cnt_r;
        end
end

always @(posedge clk_in or negedge rst_n_in)
begin
    if(rst_n_in==1'b0)
        en_key_r <= 1'b0;
    else
        en_key_r <= en_key_in;
end

always @(posedge clk_in or negedge rst_n_in)
begin
    if(rst_n_in==1'b0)
        end_cnt_r <= 1'b0;
    else
        end_cnt_r <= end_cnt_w;
end

assign  end_cnt_w = (cnt_r==4'h9) ? 1'b1 : 1'b0;


assign  cnt_out     = cnt_r;
assign  end_cal_out = end_cnt_w;
assign  en_core_out = en_data_in | busy_r;
assign  en_key_out  = en_key_r;
assign  en_data_out = end_cnt_r;
assign  busy_out    = busy_r;


endmodule
