module ynu_ti_aestop
(
 clk_in
,rst_n_in
,mode_in
,en_key_in
,en_data_in
,en_seed_in
,key_in
,data_in
,seed_in
,en_key_out
,en_data_out
,busy_out
,data_out
);

input           clk_in;
input           rst_n_in;
input   [1:0]   mode_in;
input           en_key_in;
input           en_data_in;
input           en_seed_in;
input   [127:0] key_in;
input   [127:0] data_in;
input   [127:0] seed_in;
output          en_key_out;
output          en_data_out;
output          busy_out;
output  [127:0] data_out;

wire    [3:0]   cnt_w;
wire            end_cal_w;
wire            en_core_w;
wire    [127:0] rk1_w,rk2_w,rk3_w,rk4_w,
                rd1_w,rd2_w,rd3_w,rd4_w;


ynu_ti_aesctl   U_AESCTL
(
 .clk_in        ( clk_in        )
,.rst_n_in      ( rst_n_in      )
,.en_key_in     ( en_key_in     )
,.en_data_in    ( en_data_in    )
,.cnt_out       ( cnt_w         )
,.end_cal_out   ( end_cal_w     )
,.en_core_out   ( en_core_w     )
,.en_key_out    ( en_key_out    )
,.en_data_out   ( en_data_out   )
,.busy_out      ( busy_out      )
);

ynu_ti_aescore  U_AESCORE
(
 .clk_in        ( clk_in        )
,.en_mk_in      ( en_key_in     )
,.en_ek_in      ( en_core_w     )
,.en_dr_in      ( en_core_w     )
,.en_o_in       ( en_data_out   )
,.sel_ek_in     ( en_data_in    )
,.sel_rcon_in   ( cnt_w         )
,.sel_i_in      ( en_data_in    )
,.sel_f_in      ( end_cal_w     )
,.data_in       ( data_in       )
,.key_in        ( key_in        )
,.rk1_in        ( rk1_w         )
,.rk2_in        ( rk2_w         )
,.rk3_in        ( rk3_w         )
,.rk4_in        ( rk4_w         )
,.rd1_in        ( rd1_w         )
,.rd2_in        ( rd2_w         )
,.rd3_in        ( rd3_w         )
,.rd4_in        ( rd4_w         )
,.data_out      ( data_out      )
);

ynu_ti_prng     U_PRNG
(
 .clk_in        ( clk_in        )
,.rst_n_in      ( rst_n_in      )
,.mode_in       ( mode_in       )
,.set_in        ( en_seed_in    )
,.en_in         ( en_core_w     )
,.seed_in       ( seed_in       )
,.rk1_out       ( rk1_w         )
,.rk2_out       ( rk2_w         )
,.rk3_out       ( rk3_w         )
,.rk4_out       ( rk4_w         )
,.rd1_out       ( rd1_w         )
,.rd2_out       ( rd2_w         )
,.rd3_out       ( rd3_w         )
,.rd4_out       ( rd4_w         )
);

endmodule
