module ynu_ti_enccore
(
 clk_in
,en_dr_in
,en_o_in
,sel_i_in
,sel_f_in
,d_in
,k1_in
,k2_in
,k3_in
,k4_in
,rd1_in
,rd2_in
,rd3_in
,rd4_in
,d_out
);

input           clk_in;
input           en_dr_in;
input           en_o_in;
input           sel_i_in;
input           sel_f_in;
input   [127:0] d_in;
input   [127:0] k1_in;
input   [127:0] k2_in;
input   [127:0] k3_in;
input   [127:0] k4_in;
input   [127:0] rd1_in;
input   [127:0] rd2_in;
input   [127:0] rd3_in;
input   [127:0] rd4_in;

output  [127:0] d_out;

wire    [127:0] di1_w;
wire    [127:0] temp1_w;
wire    [127:0] dt1_w;
wire    [127:0] dr1_i_w,dr1_o_w;
wire    [127:0] sr1_w;
wire    [127:0] sb1_w;
wire    [127:0] mc1_w;
wire    [127:0] data1_w;
wire    [127:0] di2_w;
wire    [127:0] temp2_w;
wire    [127:0] dt2_w;
wire    [127:0] dr2_i_w,dr2_o_w;
wire    [127:0] sr2_w;
wire    [127:0] sb2_w;
wire    [127:0] mc2_w;
wire    [127:0] data2_w;
wire    [127:0] di3_w;
wire    [127:0] temp3_w;
wire    [127:0] dt3_w;
wire    [127:0] dr3_i_w,dr3_o_w;
wire    [127:0] sr3_w;
wire    [127:0] sb3_w;
wire    [127:0] mc3_w;
wire    [127:0] data3_w;
wire    [127:0] di4_w;
wire    [127:0] temp4_w;
wire    [127:0] dt4_w;
wire    [127:0] dr4_i_w,dr4_o_w;
wire    [127:0] sr4_w;
wire    [127:0] sb4_w;
wire    [127:0] mc4_w;
wire    [127:0] data4_w;
wire    [127:0] data_w;

ynu_ti_xor2 #(128)  U_RAND_XOR1 (.d0_in(d_in), .d1_in(rd1_in), .d_out(di1_w));
ynu_ti_xor2 #(128)  U_RAND_XOR2 (.d0_in(d_in), .d1_in(rd2_in), .d_out(di2_w));
ynu_ti_xor2 #(128)  U_RAND_XOR3 (.d0_in(d_in), .d1_in(rd3_in), .d_out(di3_w));
assign  di4_w = rd4_in;

ynu_ti_mux2 #(128)  U_I_SEL1
(
 .sel_in    ( sel_i_in  )
,.d0_in     ( temp1_w   )
,.d1_in     ( di1_w     )
,.d_out     ( dt1_w     )
);

ynu_ti_mux2 #(128)  U_I_SEL2
(
 .sel_in    ( sel_i_in  )
,.d0_in     ( temp2_w   )
,.d1_in     ( di2_w     )
,.d_out     ( dt2_w     )
);

ynu_ti_mux2 #(128)  U_I_SEL3
(
 .sel_in    ( sel_i_in  )
,.d0_in     ( temp3_w   )
,.d1_in     ( di3_w     )
,.d_out     ( dt3_w     )
);

ynu_ti_mux2 #(128)  U_I_SEL4
(
 .sel_in    ( sel_i_in  )
,.d0_in     ( temp4_w   )
,.d1_in     ( di4_w     )
,.d_out     ( dt4_w     )
);

ynu_ti_xor2 #(128)  U_ARK1  (.d0_in(dt1_w), .d1_in(k1_in), .d_out(dr1_i_w));
ynu_ti_xor2 #(128)  U_ARK2  (.d0_in(dt2_w), .d1_in(k2_in), .d_out(dr2_i_w));
ynu_ti_xor2 #(128)  U_ARK3  (.d0_in(dt3_w), .d1_in(k3_in), .d_out(dr3_i_w));
ynu_ti_xor2 #(128)  U_ARK4  (.d0_in(dt4_w), .d1_in(k4_in), .d_out(dr4_i_w));

ynu_ti_ffe  #(128)  U_DATA_REG1
(
 .clk_in    ( clk_in    )
,.en_in     ( en_dr_in  )
,.d_in      ( dr1_i_w   )
,.d_out     ( dr1_o_w   )
);

ynu_ti_ffe  #(128)  U_DATA_REG2
(
 .clk_in    ( clk_in    )
,.en_in     ( en_dr_in  )
,.d_in      ( dr2_i_w   )
,.d_out     ( dr2_o_w   )
);

ynu_ti_ffe  #(128)  U_DATA_REG3
(
 .clk_in    ( clk_in    )
,.en_in     ( en_dr_in  )
,.d_in      ( dr3_i_w   )
,.d_out     ( dr3_o_w   )
);

ynu_ti_ffe  #(128)  U_DATA_REG4
(
 .clk_in    ( clk_in    )
,.en_in     ( en_dr_in  )
,.d_in      ( dr4_i_w   )
,.d_out     ( dr4_o_w   )
);

ynu_ti_shiftrow     U_SR1   (.d_in(dr1_o_w), .d_out(sr1_w));
ynu_ti_shiftrow     U_SR2   (.d_in(dr2_o_w), .d_out(sr2_w));
ynu_ti_shiftrow     U_SR3   (.d_in(dr3_o_w), .d_out(sr3_w));
ynu_ti_shiftrow     U_SR4   (.d_in(dr4_o_w), .d_out(sr4_w));

ynu_ti_subblock_s4  U_SB
(
 .d1_in     ( sr1_w )
,.d2_in     ( sr2_w )
,.d3_in     ( sr3_w )
,.d4_in     ( sr4_w )
,.d1_out    ( sb1_w )
,.d2_out    ( sb2_w )
,.d3_out    ( sb3_w )
,.d4_out    ( sb4_w )
);

ynu_ti_mixblock     U_MC1   (.d_in(sb1_w), .d_out(mc1_w));
ynu_ti_mixblock     U_MC2   (.d_in(sb2_w), .d_out(mc2_w));
ynu_ti_mixblock     U_MC3   (.d_in(sb3_w), .d_out(mc3_w));
ynu_ti_mixblock     U_MC4   (.d_in(sb4_w), .d_out(mc4_w));

ynu_ti_mux2 #(128)  U_F_SEL1
(
 .sel_in    ( sel_f_in  )
,.d0_in     ( mc1_w     )
,.d1_in     ( sb1_w     )
,.d_out     ( temp1_w   )
);

ynu_ti_mux2 #(128)  U_F_SEL2
(
 .sel_in    ( sel_f_in  )
,.d0_in     ( mc2_w     )
,.d1_in     ( sb2_w     )
,.d_out     ( temp2_w   )
);

ynu_ti_mux2 #(128)  U_F_SEL3
(
 .sel_in    ( sel_f_in  )
,.d0_in     ( mc3_w     )
,.d1_in     ( sb3_w     )
,.d_out     ( temp3_w   )
);

ynu_ti_mux2 #(128)  U_F_SEL4
(
 .sel_in    ( sel_f_in  )
,.d0_in     ( mc4_w     )
,.d1_in     ( sb4_w     )
,.d_out     ( temp4_w   )
);

ynu_ti_and2 #(128)  U_EN_DATA1
(
 .d0_in ( dr1_o_w           )
,.d1_in ( {128{en_o_in}}    )
,.d_out ( data1_w           )
);

ynu_ti_and2 #(128)  U_EN_DATA2
(
 .d0_in ( dr2_o_w           )
,.d1_in ( {128{en_o_in}}    )
,.d_out ( data2_w           )
);

ynu_ti_and2 #(128)  U_EN_DATA3
(
 .d0_in ( dr3_o_w           )
,.d1_in ( {128{en_o_in}}    )
,.d_out ( data3_w           )
);

ynu_ti_and2 #(128)  U_EN_DATA4
(
 .d0_in ( dr4_o_w           )
,.d1_in ( {128{en_o_in}}    )
,.d_out ( data4_w           )
);

ynu_ti_xor4 #(128)  U_EN_DATA
(
 .d0_in ( data1_w   )
,.d1_in ( data2_w   )
,.d2_in ( data3_w   )
,.d3_in ( data4_w   )
,.d_out ( data_w    )
);


assign  d_out = data_w;


endmodule
