module  ynu_ti_gfinv_s4
(
 d1_in
,d2_in
,d3_in
,d4_in
,d1_out
,d2_out
,d3_out
,d4_out
);

input   [7:0]   d1_in;
input   [7:0]   d2_in;
input   [7:0]   d3_in;
input   [7:0]   d4_in;
output  [7:0]   d1_out;
output  [7:0]   d2_out;
output  [7:0]   d3_out;
output  [7:0]   d4_out;

wire    [8:0]   da1_w;
wire    [8:0]   db1_w;
wire    [8:0]   dx1_w;
wire    [8:0]   dy1_w;
wire    [3:0]   yt1_w;
wire    [3:0]   dt1_w;
wire    [3:0]   u1_w;
wire    [4:0]   ut1_w;
wire    [4:0]   mx1_w;
wire            mxt1_w;
wire    [5:0]   my1_w;
wire    [3:0]   v1_w;
wire    [8:0]   va1_w;
wire    [8:0]   tp1_w;
wire    [8:0]   tn1_w;
wire    [7:0]   d1_w;
wire    [8:0]   da2_w;
wire    [8:0]   db2_w;
wire    [8:0]   dx2_w;
wire    [8:0]   dy2_w;
wire    [3:0]   yt2_w;
wire    [3:0]   dt2_w;
wire    [3:0]   u2_w;
wire    [4:0]   ut2_w;
wire    [4:0]   mx2_w;
wire            mxt2_w;
wire    [5:0]   my2_w;
wire    [3:0]   v2_w;
wire    [8:0]   va2_w;
wire    [8:0]   tp2_w;
wire    [8:0]   tn2_w;
wire    [7:0]   d2_w;
wire    [8:0]   da3_w;
wire    [8:0]   db3_w;
wire    [8:0]   dx3_w;
wire    [8:0]   dy3_w;
wire    [3:0]   yt3_w;
wire    [3:0]   dt3_w;
wire    [3:0]   u3_w;
wire    [4:0]   ut3_w;
wire    [4:0]   mx3_w;
wire            mxt3_w;
wire    [5:0]   my3_w;
wire    [3:0]   v3_w;
wire    [8:0]   va3_w;
wire    [8:0]   tp3_w;
wire    [8:0]   tn3_w;
wire    [7:0]   d3_w;
wire    [8:0]   da4_w;
wire    [8:0]   db4_w;
wire    [8:0]   dx4_w;
wire    [8:0]   dy4_w;
wire    [3:0]   yt4_w;
wire    [3:0]   dt4_w;
wire    [3:0]   u4_w;
wire    [4:0]   ut4_w;
wire    [4:0]   mx4_w;
wire            mxt4_w;
wire    [5:0]   my4_w;
wire    [3:0]   v4_w;
wire    [8:0]   va4_w;
wire    [8:0]   tp4_w;
wire    [8:0]   tn4_w;
wire    [7:0]   d4_w;


// DA1
/*********************************************************/
assign  da1_w[0] = d1_in[0];

ynu_ti_xor2     U_DA1_1
(
 .d0_in ( d1_in[0]  )
,.d1_in ( d1_in[1]  )
,.d_out ( da1_w[1]  )
);

assign  da1_w[2] = d1_in[1];

ynu_ti_xor2     U_DA1_3
(
 .d0_in ( d1_in[0]  )
,.d1_in ( d1_in[2]  )
,.d_out ( da1_w[3]  )
);

ynu_ti_xor4     U_DA1_4
(
 .d0_in ( d1_in[0]  )
,.d1_in ( d1_in[1]  )
,.d2_in ( d1_in[2]  )
,.d3_in ( d1_in[3]  )
,.d_out ( da1_w[4]  )
);

ynu_ti_xor2     U_DA1_5
(
 .d0_in ( d1_in[1]  )
,.d1_in ( d1_in[3]  )
,.d_out ( da1_w[5]  )
);

assign  da1_w[6] = d1_in[2];

ynu_ti_xor2     U_DA1_7
(
 .d0_in ( d1_in[2]  )
,.d1_in ( d1_in[3]  )
,.d_out ( da1_w[7]  )
);

assign  da1_w[8] = d1_in[3];

// DB1
/*********************************************************/
assign  db1_w[0] = d1_in[4];

ynu_ti_xor2     U_DB1_1
(
 .d0_in ( d1_in[4]  )
,.d1_in ( d1_in[5]  )
,.d_out ( db1_w[1]  )
);

assign  db1_w[2] = d1_in[5];

ynu_ti_xor2     U_DB1_3
(
 .d0_in ( d1_in[4]  )
,.d1_in ( d1_in[6]  )
,.d_out ( db1_w[3]  )
);

ynu_ti_xor4     U_DB1_4
(
 .d0_in ( d1_in[4]  )
,.d1_in ( d1_in[5]  )
,.d2_in ( d1_in[6]  )
,.d3_in ( d1_in[7]  )
,.d_out ( db1_w[4]  )
);

ynu_ti_xor2     U_DB1_5
(
 .d0_in ( d1_in[5]  )
,.d1_in ( d1_in[7]  )
,.d_out ( db1_w[5]  )
);

assign  db1_w[6] = d1_in[6];

ynu_ti_xor2     U_DB1_7
(
 .d0_in ( d1_in[6]  )
,.d1_in ( d1_in[7]  )
,.d_out ( db1_w[7]  )
);

assign  db1_w[8] = d1_in[7];

// DX1
/*********************************************************/
ynu_ti_xor2     #(9)    U_DX1
(
 .d0_in ( da1_w )
,.d1_in ( db1_w )
,.d_out ( dx1_w )
);

// YT1
/*********************************************************/
ynu_ti_xor4     U_YT1_0
(
 .d0_in ( dy1_w[0]  )
,.d1_in ( dy1_w[2]  )
,.d2_in ( dy1_w[6]  )
,.d3_in ( dy1_w[7]  )
,.d_out ( yt1_w[0]  )
);

ynu_ti_xor4     U_YT1_1
(
 .d0_in ( dy1_w[0]  )
,.d1_in ( dy1_w[1]  )
,.d2_in ( dy1_w[7]  )
,.d3_in ( dy1_w[8]  )
,.d_out ( yt1_w[1]  )
);

ynu_ti_xor4     U_YT1_2
(
 .d0_in ( dy1_w[0]  )
,.d1_in ( dy1_w[2]  )
,.d2_in ( dy1_w[3]  )
,.d3_in ( dy1_w[5]  )
,.d_out ( yt1_w[2]  )
);

ynu_ti_xor4     U_YT1_3
(
 .d0_in ( dy1_w[0]  )
,.d1_in ( dy1_w[1]  )
,.d2_in ( dy1_w[3]  )
,.d3_in ( dy1_w[4]  )
,.d_out ( yt1_w[3]  )
);

// DT2
/*********************************************************/
ynu_ti_xor2     U_DT1_0
(
 .d0_in ( d1_in[6]  )
,.d1_in ( d1_in[7]  )
,.d_out ( dt1_w[0]  )
);

assign  dt1_w[1] = d1_in[7];

ynu_ti_xor2     U_DT1_2
(
 .d0_in ( d1_in[4]  )
,.d1_in ( d1_in[7]  )
,.d_out ( dt1_w[2]  )
);

ynu_ti_xor3     U_DT1_3
(
 .d0_in ( d1_in[4]  )
,.d1_in ( d1_in[5]  )
,.d2_in ( d1_in[6]  )
,.d_out ( dt1_w[3]  )
);

// U1
/*********************************************************/
ynu_ti_xor2     #(4)    U_U1
(
 .d0_in ( yt1_w )
,.d1_in ( dt1_w )
,.d_out ( u1_w  )
);

// UT1
/*********************************************************/
ynu_ti_xor2     U_UT1_0
(
 .d0_in ( u1_w[0]   )
,.d1_in ( u1_w[1]   )
,.d_out ( ut1_w[0]  )
);

ynu_ti_xor2     U_UT1_1
(
 .d0_in ( u1_w[0]   )
,.d1_in ( u1_w[2]   )
,.d_out ( ut1_w[1]  )
);

ynu_ti_xor2     U_UT1_2
(
 .d0_in ( u1_w[1]   )
,.d1_in ( u1_w[3]   )
,.d_out ( ut1_w[2]  )
);

ynu_ti_xor2     U_UT1_3
(
 .d0_in ( u1_w[2]   )
,.d1_in ( u1_w[3]   )
,.d_out ( ut1_w[3]  )
);

ynu_ti_xor2     U_UT1_4
(
 .d0_in ( ut1_w[0]  )
,.d1_in ( ut1_w[3]  )
,.d_out ( ut1_w[4]  )
);

// MX1
/*********************************************************/
ynu_ti_xor3     U_MX1_3
(
 .d0_in ( mx1_w[0]  )
,.d1_in ( mx1_w[2]  )
,.d2_in ( u1_w[3]   )
,.d_out ( mx1_w[3]  )
);

ynu_ti_xor3     U_MX1_4
(
 .d0_in ( mx1_w[0]  )
,.d1_in ( mx1_w[1]  )
,.d2_in ( u1_w[2]   )
,.d_out ( mx1_w[4]  )
);

// MXT1
/*********************************************************/
ynu_ti_xor2     U_MXT1
(
 .d0_in ( mx1_w[3]  )
,.d1_in ( mx1_w[4]  )
,.d_out ( mxt1_w    )
);

// V1
/*********************************************************/
ynu_ti_xor2     U_V1_0
(
 .d0_in ( my1_w[0]  )
,.d1_in ( my1_w[2]  )
,.d_out ( v1_w[0]   )
);

ynu_ti_xor2     U_V1_1
(
 .d0_in ( my1_w[0]  )
,.d1_in ( my1_w[1]  )
,.d_out ( v1_w[1]   )
);

ynu_ti_xor2     U_V1_2
(
 .d0_in ( my1_w[3]  )
,.d1_in ( my1_w[5]  )
,.d_out ( v1_w[2]   )
);

ynu_ti_xor2     U_V1_3
(
 .d0_in ( my1_w[3]  )
,.d1_in ( my1_w[4]  )
,.d_out ( v1_w[3]   )
);

// VA1
/*********************************************************/
assign  va1_w[0] = v1_w[0];

ynu_ti_xor2     U_VA1_1
(
 .d0_in ( v1_w[0]   )
,.d1_in ( v1_w[1]   )
,.d_out ( va1_w[1]  )
);

assign  va1_w[2] = v1_w[1];

ynu_ti_xor2     U_VA1_3
(
 .d0_in ( v1_w[0]   )
,.d1_in ( v1_w[2]   )
,.d_out ( va1_w[3]  )
);

ynu_ti_xor4     U_VA1_4
(
 .d0_in ( v1_w[0]   )
,.d1_in ( v1_w[1]   )
,.d2_in ( v1_w[2]   )
,.d3_in ( v1_w[3]   )
,.d_out ( va1_w[4]  )
);

ynu_ti_xor2     U_VA1_5
(
 .d0_in ( v1_w[1]   )
,.d1_in ( v1_w[3]   )
,.d_out ( va1_w[5]  )
);

assign  va1_w[6] = v1_w[2];

ynu_ti_xor2     U_VA1_6
(
 .d0_in ( v1_w[2]   )
,.d1_in ( v1_w[3]   )
,.d_out ( va1_w[7]  )
);

assign  va1_w[8] = v1_w[3];

// D1
/*********************************************************/
ynu_ti_xor4     U_D1_0
(
 .d0_in ( tp1_w[0]  )
,.d1_in ( tp1_w[2]  )
,.d2_in ( tp1_w[6]  )
,.d3_in ( tp1_w[7]  )
,.d_out ( d1_w[0]   )
);

ynu_ti_xor4     U_D1_1
(
 .d0_in ( tp1_w[0]  )
,.d1_in ( tp1_w[1]  )
,.d2_in ( tp1_w[7]  )
,.d3_in ( tp1_w[8]  )
,.d_out ( d1_w[1]   )
);

ynu_ti_xor4     U_D1_2
(
 .d0_in ( tp1_w[0]  )
,.d1_in ( tp1_w[2]  )
,.d2_in ( tp1_w[3]  )
,.d3_in ( tp1_w[5]  )
,.d_out ( d1_w[2]   )
);

ynu_ti_xor4     U_D1_3
(
 .d0_in ( tp1_w[0]  )
,.d1_in ( tp1_w[1]  )
,.d2_in ( tp1_w[3]  )
,.d3_in ( tp1_w[4]  )
,.d_out ( d1_w[3]   )
);

ynu_ti_xor4     U_D1_4
(
 .d0_in ( tn1_w[0]  )
,.d1_in ( tn1_w[2]  )
,.d2_in ( tn1_w[6]  )
,.d3_in ( tn1_w[7]  )
,.d_out ( d1_w[4]   )
);

ynu_ti_xor4     U_D1_5
(
 .d0_in ( tn1_w[0]  )
,.d1_in ( tn1_w[1]  )
,.d2_in ( tn1_w[7]  )
,.d3_in ( tn1_w[8]  )
,.d_out ( d1_w[5]   )
);

ynu_ti_xor4     U_D1_6
(
 .d0_in ( tn1_w[0]  )
,.d1_in ( tn1_w[2]  )
,.d2_in ( tn1_w[3]  )
,.d3_in ( tn1_w[5]  )
,.d_out ( d1_w[6]   )
);

ynu_ti_xor4     U_D1_7
(
 .d0_in ( tn1_w[0]  )
,.d1_in ( tn1_w[1]  )
,.d2_in ( tn1_w[3]  )
,.d3_in ( tn1_w[4]  )
,.d_out ( d1_w[7]   )
);

assign  d1_out = d1_w;
/*************************************************************************/

// DA2
/*********************************************************/
assign  da2_w[0] = d2_in[0];

ynu_ti_xor2     U_DA2_1
(
 .d0_in ( d2_in[0]  )
,.d1_in ( d2_in[1]  )
,.d_out ( da2_w[1]  )
);

assign  da2_w[2] = d2_in[1];

ynu_ti_xor2     U_DA2_3
(
 .d0_in ( d2_in[0]  )
,.d1_in ( d2_in[2]  )
,.d_out ( da2_w[3]  )
);

ynu_ti_xor4     U_DA2_4
(
 .d0_in ( d2_in[0]  )
,.d1_in ( d2_in[1]  )
,.d2_in ( d2_in[2]  )
,.d3_in ( d2_in[3]  )
,.d_out ( da2_w[4]  )
);

ynu_ti_xor2     U_DA2_5
(
 .d0_in ( d2_in[1]  )
,.d1_in ( d2_in[3]  )
,.d_out ( da2_w[5]  )
);

assign  da2_w[6] = d2_in[2];

ynu_ti_xor2     U_DA2_7
(
 .d0_in ( d2_in[2]  )
,.d1_in ( d2_in[3]  )
,.d_out ( da2_w[7]  )
);

assign  da2_w[8] = d2_in[3];

// DB2
/*********************************************************/
assign  db2_w[0] = d2_in[4];

ynu_ti_xor2     U_DB2_1
(
 .d0_in ( d2_in[4]  )
,.d1_in ( d2_in[5]  )
,.d_out ( db2_w[1]  )
);

assign  db2_w[2] = d2_in[5];

ynu_ti_xor2     U_DB2_3
(
 .d0_in ( d2_in[4]  )
,.d1_in ( d2_in[6]  )
,.d_out ( db2_w[3]  )
);

ynu_ti_xor4     U_DB2_4
(
 .d0_in ( d2_in[4]  )
,.d1_in ( d2_in[5]  )
,.d2_in ( d2_in[6]  )
,.d3_in ( d2_in[7]  )
,.d_out ( db2_w[4]  )
);

ynu_ti_xor2     U_DB2_5
(
 .d0_in ( d2_in[5]  )
,.d1_in ( d2_in[7]  )
,.d_out ( db2_w[5]  )
);

assign  db2_w[6] = d2_in[6];

ynu_ti_xor2     U_DB2_7
(
 .d0_in ( d2_in[6]  )
,.d1_in ( d2_in[7]  )
,.d_out ( db2_w[7]  )
);

assign  db2_w[8] = d2_in[7];

// DX2
/*********************************************************/
ynu_ti_xor2     #(9)    U_DX2
(
 .d0_in ( da2_w )
,.d1_in ( db2_w )
,.d_out ( dx2_w )
);

// YT2
/*********************************************************/
ynu_ti_xor4     U_YT2_0
(
 .d0_in ( dy2_w[0]  )
,.d1_in ( dy2_w[2]  )
,.d2_in ( dy2_w[6]  )
,.d3_in ( dy2_w[7]  )
,.d_out ( yt2_w[0]  )
);

ynu_ti_xor4     U_YT2_1
(
 .d0_in ( dy2_w[0]  )
,.d1_in ( dy2_w[1]  )
,.d2_in ( dy2_w[7]  )
,.d3_in ( dy2_w[8]  )
,.d_out ( yt2_w[1]  )
);

ynu_ti_xor4     U_YT2_2
(
 .d0_in ( dy2_w[0]  )
,.d1_in ( dy2_w[2]  )
,.d2_in ( dy2_w[3]  )
,.d3_in ( dy2_w[5]  )
,.d_out ( yt2_w[2]  )
);

ynu_ti_xor4     U_YT2_3
(
 .d0_in ( dy2_w[0]  )
,.d1_in ( dy2_w[1]  )
,.d2_in ( dy2_w[3]  )
,.d3_in ( dy2_w[4]  )
,.d_out ( yt2_w[3]  )
);

// DT2
/*********************************************************/
ynu_ti_xor2     U_DT2_0
(
 .d0_in ( d2_in[6]  )
,.d1_in ( d2_in[7]  )
,.d_out ( dt2_w[0]  )
);

assign  dt2_w[1] = d2_in[7];

ynu_ti_xor2     U_DT2_2
(
 .d0_in ( d2_in[4]  )
,.d1_in ( d2_in[7]  )
,.d_out ( dt2_w[2]  )
);

ynu_ti_xor3     U_DT2_3
(
 .d0_in ( d2_in[4]  )
,.d1_in ( d2_in[5]  )
,.d2_in ( d2_in[6]  )
,.d_out ( dt2_w[3]  )
);

// U2
/*********************************************************/
ynu_ti_xor2     #(4)    U_U2
(
 .d0_in ( yt2_w )
,.d1_in ( dt2_w )
,.d_out ( u2_w  )
);

// UT2
/*********************************************************/
ynu_ti_xor2     U_UT2_0
(
 .d0_in ( u2_w[0]   )
,.d1_in ( u2_w[1]   )
,.d_out ( ut2_w[0]  )
);

ynu_ti_xor2     U_UT2_1
(
 .d0_in ( u2_w[0]   )
,.d1_in ( u2_w[2]   )
,.d_out ( ut2_w[1]  )
);

ynu_ti_xor2     U_UT2_2
(
 .d0_in ( u2_w[1]   )
,.d1_in ( u2_w[3]   )
,.d_out ( ut2_w[2]  )
);

ynu_ti_xor2     U_UT2_3
(
 .d0_in ( u2_w[2]   )
,.d1_in ( u2_w[3]   )
,.d_out ( ut2_w[3]  )
);

ynu_ti_xor2     U_UT2_4
(
 .d0_in ( ut2_w[0]  )
,.d1_in ( ut2_w[3]  )
,.d_out ( ut2_w[4]  )
);

// MX2
/*********************************************************/
ynu_ti_xor3     U_MX2_3
(
 .d0_in ( mx2_w[0]  )
,.d1_in ( mx2_w[2]  )
,.d2_in ( u2_w[3]   )
,.d_out ( mx2_w[3]  )
);

ynu_ti_xor3     U_MX2_4
(
 .d0_in ( mx2_w[0]  )
,.d1_in ( mx2_w[1]  )
,.d2_in ( u2_w[2]   )
,.d_out ( mx2_w[4]  )
);

// MXT2
/*********************************************************/
ynu_ti_xor2     U_MXT2
(
 .d0_in ( mx2_w[3]  )
,.d1_in ( mx2_w[4]  )
,.d_out ( mxt2_w    )
);

// V2
/*********************************************************/
ynu_ti_xor2     U_V2_0
(
 .d0_in ( my2_w[0]  )
,.d1_in ( my2_w[2]  )
,.d_out ( v2_w[0]   )
);

ynu_ti_xor2     U_V2_1
(
 .d0_in ( my2_w[0]  )
,.d1_in ( my2_w[1]  )
,.d_out ( v2_w[1]   )
);

ynu_ti_xor2     U_V2_2
(
 .d0_in ( my2_w[3]  )
,.d1_in ( my2_w[5]  )
,.d_out ( v2_w[2]   )
);

ynu_ti_xor2     U_V2_3
(
 .d0_in ( my2_w[3]  )
,.d1_in ( my2_w[4]  )
,.d_out ( v2_w[3]   )
);

// VA2
/*********************************************************/
assign  va2_w[0] = v2_w[0];

ynu_ti_xor2     U_VA2_1
(
 .d0_in ( v2_w[0]   )
,.d1_in ( v2_w[1]   )
,.d_out ( va2_w[1]  )
);

assign  va2_w[2] = v2_w[1];

ynu_ti_xor2     U_VA2_3
(
 .d0_in ( v2_w[0]   )
,.d1_in ( v2_w[2]   )
,.d_out ( va2_w[3]  )
);

ynu_ti_xor4     U_VA2_4
(
 .d0_in ( v2_w[0]   )
,.d1_in ( v2_w[1]   )
,.d2_in ( v2_w[2]   )
,.d3_in ( v2_w[3]   )
,.d_out ( va2_w[4]  )
);

ynu_ti_xor2     U_VA2_5
(
 .d0_in ( v2_w[1]   )
,.d1_in ( v2_w[3]   )
,.d_out ( va2_w[5]  )
);

assign  va2_w[6] = v2_w[2];

ynu_ti_xor2     U_VA2_6
(
 .d0_in ( v2_w[2]   )
,.d1_in ( v2_w[3]   )
,.d_out ( va2_w[7]  )
);

assign  va2_w[8] = v2_w[3];

// D2
/*********************************************************/
ynu_ti_xor4     U_D2_0
(
 .d0_in ( tp2_w[0]  )
,.d1_in ( tp2_w[2]  )
,.d2_in ( tp2_w[6]  )
,.d3_in ( tp2_w[7]  )
,.d_out ( d2_w[0]   )
);

ynu_ti_xor4     U_D2_1
(
 .d0_in ( tp2_w[0]  )
,.d1_in ( tp2_w[1]  )
,.d2_in ( tp2_w[7]  )
,.d3_in ( tp2_w[8]  )
,.d_out ( d2_w[1]   )
);

ynu_ti_xor4     U_D2_2
(
 .d0_in ( tp2_w[0]  )
,.d1_in ( tp2_w[2]  )
,.d2_in ( tp2_w[3]  )
,.d3_in ( tp2_w[5]  )
,.d_out ( d2_w[2]   )
);

ynu_ti_xor4     U_D2_3
(
 .d0_in ( tp2_w[0]  )
,.d1_in ( tp2_w[1]  )
,.d2_in ( tp2_w[3]  )
,.d3_in ( tp2_w[4]  )
,.d_out ( d2_w[3]   )
);

ynu_ti_xor4     U_D2_4
(
 .d0_in ( tn2_w[0]  )
,.d1_in ( tn2_w[2]  )
,.d2_in ( tn2_w[6]  )
,.d3_in ( tn2_w[7]  )
,.d_out ( d2_w[4]   )
);

ynu_ti_xor4     U_D2_5
(
 .d0_in ( tn2_w[0]  )
,.d1_in ( tn2_w[1]  )
,.d2_in ( tn2_w[7]  )
,.d3_in ( tn2_w[8]  )
,.d_out ( d2_w[5]   )
);

ynu_ti_xor4     U_D2_6
(
 .d0_in ( tn2_w[0]  )
,.d1_in ( tn2_w[2]  )
,.d2_in ( tn2_w[3]  )
,.d3_in ( tn2_w[5]  )
,.d_out ( d2_w[6]   )
);

ynu_ti_xor4     U_D2_7
(
 .d0_in ( tn2_w[0]  )
,.d1_in ( tn2_w[1]  )
,.d2_in ( tn2_w[3]  )
,.d3_in ( tn2_w[4]  )
,.d_out ( d2_w[7]   )
);

assign  d2_out = d2_w;
/*************************************************************************/

// DA3
/*********************************************************/
assign  da3_w[0] = d3_in[0];

ynu_ti_xor2     U_DA3_1
(
 .d0_in ( d3_in[0]  )
,.d1_in ( d3_in[1]  )
,.d_out ( da3_w[1]  )
);

assign  da3_w[2] = d3_in[1];

ynu_ti_xor2     U_DA3_3
(
 .d0_in ( d3_in[0]  )
,.d1_in ( d3_in[2]  )
,.d_out ( da3_w[3]  )
);

ynu_ti_xor4     U_DA3_4
(
 .d0_in ( d3_in[0]  )
,.d1_in ( d3_in[1]  )
,.d2_in ( d3_in[2]  )
,.d3_in ( d3_in[3]  )
,.d_out ( da3_w[4]  )
);

ynu_ti_xor2     U_DA3_5
(
 .d0_in ( d3_in[1]  )
,.d1_in ( d3_in[3]  )
,.d_out ( da3_w[5]  )
);

assign  da3_w[6] = d3_in[2];

ynu_ti_xor2     U_DA3_7
(
 .d0_in ( d3_in[2]  )
,.d1_in ( d3_in[3]  )
,.d_out ( da3_w[7]  )
);

assign  da3_w[8] = d3_in[3];

// DB3
/*********************************************************/
assign  db3_w[0] = d3_in[4];

ynu_ti_xor2     U_DB3_1
(
 .d0_in ( d3_in[4]  )
,.d1_in ( d3_in[5]  )
,.d_out ( db3_w[1]  )
);

assign  db3_w[2] = d3_in[5];

ynu_ti_xor2     U_DB3_3
(
 .d0_in ( d3_in[4]  )
,.d1_in ( d3_in[6]  )
,.d_out ( db3_w[3]  )
);

ynu_ti_xor4     U_DB3_4
(
 .d0_in ( d3_in[4]  )
,.d1_in ( d3_in[5]  )
,.d2_in ( d3_in[6]  )
,.d3_in ( d3_in[7]  )
,.d_out ( db3_w[4]  )
);

ynu_ti_xor2     U_DB3_5
(
 .d0_in ( d3_in[5]  )
,.d1_in ( d3_in[7]  )
,.d_out ( db3_w[5]  )
);

assign  db3_w[6] = d3_in[6];

ynu_ti_xor2     U_DB3_7
(
 .d0_in ( d3_in[6]  )
,.d1_in ( d3_in[7]  )
,.d_out ( db3_w[7]  )
);

assign  db3_w[8] = d3_in[7];

// DX3
/*********************************************************/
ynu_ti_xor2     #(9)    U_DX3
(
 .d0_in ( da3_w )
,.d1_in ( db3_w )
,.d_out ( dx3_w )
);

// YT3
/*********************************************************/
ynu_ti_xor4     U_YT3_0
(
 .d0_in ( dy3_w[0]  )
,.d1_in ( dy3_w[2]  )
,.d2_in ( dy3_w[6]  )
,.d3_in ( dy3_w[7]  )
,.d_out ( yt3_w[0]  )
);

ynu_ti_xor4     U_YT3_1
(
 .d0_in ( dy3_w[0]  )
,.d1_in ( dy3_w[1]  )
,.d2_in ( dy3_w[7]  )
,.d3_in ( dy3_w[8]  )
,.d_out ( yt3_w[1]  )
);

ynu_ti_xor4     U_YT3_2
(
 .d0_in ( dy3_w[0]  )
,.d1_in ( dy3_w[2]  )
,.d2_in ( dy3_w[3]  )
,.d3_in ( dy3_w[5]  )
,.d_out ( yt3_w[2]  )
);

ynu_ti_xor4     U_YT3_3
(
 .d0_in ( dy3_w[0]  )
,.d1_in ( dy3_w[1]  )
,.d2_in ( dy3_w[3]  )
,.d3_in ( dy3_w[4]  )
,.d_out ( yt3_w[3]  )
);

// DT3
/*********************************************************/
ynu_ti_xor2     U_DT3_0
(
 .d0_in ( d3_in[6]  )
,.d1_in ( d3_in[7]  )
,.d_out ( dt3_w[0]  )
);

assign  dt3_w[1] = d3_in[7];

ynu_ti_xor2     U_DT3_2
(
 .d0_in ( d3_in[4]  )
,.d1_in ( d3_in[7]  )
,.d_out ( dt3_w[2]  )
);

ynu_ti_xor3     U_DT3_3
(
 .d0_in ( d3_in[4]  )
,.d1_in ( d3_in[5]  )
,.d2_in ( d3_in[6]  )
,.d_out ( dt3_w[3]  )
);

// U3
/*********************************************************/
ynu_ti_xor2     #(4)    U_U3
(
 .d0_in ( yt3_w )
,.d1_in ( dt3_w )
,.d_out ( u3_w  )
);

// UT3
/*********************************************************/
ynu_ti_xor2     U_UT3_0
(
 .d0_in ( u3_w[0]   )
,.d1_in ( u3_w[1]   )
,.d_out ( ut3_w[0]  )
);

ynu_ti_xor2     U_UT3_1
(
 .d0_in ( u3_w[0]   )
,.d1_in ( u3_w[2]   )
,.d_out ( ut3_w[1]  )
);

ynu_ti_xor2     U_UT3_2
(
 .d0_in ( u3_w[1]   )
,.d1_in ( u3_w[3]   )
,.d_out ( ut3_w[2]  )
);

ynu_ti_xor2     U_UT3_3
(
 .d0_in ( u3_w[2]   )
,.d1_in ( u3_w[3]   )
,.d_out ( ut3_w[3]  )
);

ynu_ti_xor2     U_UT3_4
(
 .d0_in ( ut3_w[0]  )
,.d1_in ( ut3_w[3]  )
,.d_out ( ut3_w[4]  )
);

// MX3
/*********************************************************/
ynu_ti_xor3     U_MX3_3
(
 .d0_in ( mx3_w[0]  )
,.d1_in ( mx3_w[2]  )
,.d2_in ( u3_w[3]   )
,.d_out ( mx3_w[3]  )
);

ynu_ti_xor3     U_MX3_4
(
 .d0_in ( mx3_w[0]  )
,.d1_in ( mx3_w[1]  )
,.d2_in ( u3_w[2]   )
,.d_out ( mx3_w[4]  )
);

// MXT3
/*********************************************************/
ynu_ti_xor2     U_MXT3
(
 .d0_in ( mx3_w[3]  )
,.d1_in ( mx3_w[4]  )
,.d_out ( mxt3_w    )
);

// V3
/*********************************************************/
ynu_ti_xor2     U_V3_0
(
 .d0_in ( my3_w[0]  )
,.d1_in ( my3_w[2]  )
,.d_out ( v3_w[0]   )
);

ynu_ti_xor2     U_V3_1
(
 .d0_in ( my3_w[0]  )
,.d1_in ( my3_w[1]  )
,.d_out ( v3_w[1]   )
);

ynu_ti_xor2     U_V3_2
(
 .d0_in ( my3_w[3]  )
,.d1_in ( my3_w[5]  )
,.d_out ( v3_w[2]   )
);

ynu_ti_xor2     U_V3_3
(
 .d0_in ( my3_w[3]  )
,.d1_in ( my3_w[4]  )
,.d_out ( v3_w[3]   )
);

// VA3
/*********************************************************/
assign  va3_w[0] = v3_w[0];

ynu_ti_xor2     U_VA3_1
(
 .d0_in ( v3_w[0]   )
,.d1_in ( v3_w[1]   )
,.d_out ( va3_w[1]  )
);

assign  va3_w[2] = v3_w[1];

ynu_ti_xor2     U_VA3_3
(
 .d0_in ( v3_w[0]   )
,.d1_in ( v3_w[2]   )
,.d_out ( va3_w[3]  )
);

ynu_ti_xor4     U_VA3_4
(
 .d0_in ( v3_w[0]   )
,.d1_in ( v3_w[1]   )
,.d2_in ( v3_w[2]   )
,.d3_in ( v3_w[3]   )
,.d_out ( va3_w[4]  )
);

ynu_ti_xor2     U_VA3_5
(
 .d0_in ( v3_w[1]   )
,.d1_in ( v3_w[3]   )
,.d_out ( va3_w[5]  )
);

assign  va3_w[6] = v3_w[2];

ynu_ti_xor2     U_VA3_6
(
 .d0_in ( v3_w[2]   )
,.d1_in ( v3_w[3]   )
,.d_out ( va3_w[7]  )
);

assign  va3_w[8] = v3_w[3];

// D3
/*********************************************************/
ynu_ti_xor4     U_D3_0
(
 .d0_in ( tp3_w[0]  )
,.d1_in ( tp3_w[2]  )
,.d2_in ( tp3_w[6]  )
,.d3_in ( tp3_w[7]  )
,.d_out ( d3_w[0]   )
);

ynu_ti_xor4     U_D3_1
(
 .d0_in ( tp3_w[0]  )
,.d1_in ( tp3_w[1]  )
,.d2_in ( tp3_w[7]  )
,.d3_in ( tp3_w[8]  )
,.d_out ( d3_w[1]   )
);

ynu_ti_xor4     U_D3_2
(
 .d0_in ( tp3_w[0]  )
,.d1_in ( tp3_w[2]  )
,.d2_in ( tp3_w[3]  )
,.d3_in ( tp3_w[5]  )
,.d_out ( d3_w[2]   )
);

ynu_ti_xor4     U_D3_3
(
 .d0_in ( tp3_w[0]  )
,.d1_in ( tp3_w[1]  )
,.d2_in ( tp3_w[3]  )
,.d3_in ( tp3_w[4]  )
,.d_out ( d3_w[3]   )
);

ynu_ti_xor4     U_D3_4
(
 .d0_in ( tn3_w[0]  )
,.d1_in ( tn3_w[2]  )
,.d2_in ( tn3_w[6]  )
,.d3_in ( tn3_w[7]  )
,.d_out ( d3_w[4]   )
);

ynu_ti_xor4     U_D3_5
(
 .d0_in ( tn3_w[0]  )
,.d1_in ( tn3_w[1]  )
,.d2_in ( tn3_w[7]  )
,.d3_in ( tn3_w[8]  )
,.d_out ( d3_w[5]   )
);

ynu_ti_xor4     U_D3_6
(
 .d0_in ( tn3_w[0]  )
,.d1_in ( tn3_w[2]  )
,.d2_in ( tn3_w[3]  )
,.d3_in ( tn3_w[5]  )
,.d_out ( d3_w[6]   )
);

ynu_ti_xor4     U_D3_7
(
 .d0_in ( tn3_w[0]  )
,.d1_in ( tn3_w[1]  )
,.d2_in ( tn3_w[3]  )
,.d3_in ( tn3_w[4]  )
,.d_out ( d3_w[7]   )
);

assign  d3_out = d3_w;
/*************************************************************************/

// DA4
/*********************************************************/
assign  da4_w[0] = d4_in[0];

ynu_ti_xor2     U_DA4_1
(
 .d0_in ( d4_in[0]  )
,.d1_in ( d4_in[1]  )
,.d_out ( da4_w[1]  )
);

assign  da4_w[2] = d4_in[1];

ynu_ti_xor2     U_DA4_3
(
 .d0_in ( d4_in[0]  )
,.d1_in ( d4_in[2]  )
,.d_out ( da4_w[3]  )
);

ynu_ti_xor4     U_DA4_4
(
 .d0_in ( d4_in[0]  )
,.d1_in ( d4_in[1]  )
,.d2_in ( d4_in[2]  )
,.d3_in ( d4_in[3]  )
,.d_out ( da4_w[4]  )
);

ynu_ti_xor2     U_DA4_5
(
 .d0_in ( d4_in[1]  )
,.d1_in ( d4_in[3]  )
,.d_out ( da4_w[5]  )
);

assign  da4_w[6] = d4_in[2];

ynu_ti_xor2     U_DA4_7
(
 .d0_in ( d4_in[2]  )
,.d1_in ( d4_in[3]  )
,.d_out ( da4_w[7]  )
);

assign  da4_w[8] = d4_in[3];

// DB4
/*********************************************************/
assign  db4_w[0] = d4_in[4];

ynu_ti_xor2     U_DB4_1
(
 .d0_in ( d4_in[4]  )
,.d1_in ( d4_in[5]  )
,.d_out ( db4_w[1]  )
);

assign  db4_w[2] = d4_in[5];

ynu_ti_xor2     U_DB4_3
(
 .d0_in ( d4_in[4]  )
,.d1_in ( d4_in[6]  )
,.d_out ( db4_w[3]  )
);

ynu_ti_xor4     U_DB4_4
(
 .d0_in ( d4_in[4]  )
,.d1_in ( d4_in[5]  )
,.d2_in ( d4_in[6]  )
,.d3_in ( d4_in[7]  )
,.d_out ( db4_w[4]  )
);

ynu_ti_xor2     U_DB4_5
(
 .d0_in ( d4_in[5]  )
,.d1_in ( d4_in[7]  )
,.d_out ( db4_w[5]  )
);

assign  db4_w[6] = d4_in[6];

ynu_ti_xor2     U_DB4_7
(
 .d0_in ( d4_in[6]  )
,.d1_in ( d4_in[7]  )
,.d_out ( db4_w[7]  )
);

assign  db4_w[8] = d4_in[7];

// DX4
/*********************************************************/
ynu_ti_xor2     #(9)    U_DX4
(
 .d0_in ( da4_w )
,.d1_in ( db4_w )
,.d_out ( dx4_w )
);

// YT4
/*********************************************************/
ynu_ti_xor4     U_YT4_0
(
 .d0_in ( dy4_w[0]  )
,.d1_in ( dy4_w[2]  )
,.d2_in ( dy4_w[6]  )
,.d3_in ( dy4_w[7]  )
,.d_out ( yt4_w[0]  )
);

ynu_ti_xor4     U_YT4_1
(
 .d0_in ( dy4_w[0]  )
,.d1_in ( dy4_w[1]  )
,.d2_in ( dy4_w[7]  )
,.d3_in ( dy4_w[8]  )
,.d_out ( yt4_w[1]  )
);

ynu_ti_xor4     U_YT4_2
(
 .d0_in ( dy4_w[0]  )
,.d1_in ( dy4_w[2]  )
,.d2_in ( dy4_w[3]  )
,.d3_in ( dy4_w[5]  )
,.d_out ( yt4_w[2]  )
);

ynu_ti_xor4     U_YT4_3
(
 .d0_in ( dy4_w[0]  )
,.d1_in ( dy4_w[1]  )
,.d2_in ( dy4_w[3]  )
,.d3_in ( dy4_w[4]  )
,.d_out ( yt4_w[3]  )
);

// DT4
/*********************************************************/
ynu_ti_xor2     U_DT4_0
(
 .d0_in ( d4_in[6]  )
,.d1_in ( d4_in[7]  )
,.d_out ( dt4_w[0]  )
);

assign  dt4_w[1] = d4_in[7];

ynu_ti_xor2     U_DT4_2
(
 .d0_in ( d4_in[4]  )
,.d1_in ( d4_in[7]  )
,.d_out ( dt4_w[2]  )
);

ynu_ti_xor3     U_DT4_3
(
 .d0_in ( d4_in[4]  )
,.d1_in ( d4_in[5]  )
,.d2_in ( d4_in[6]  )
,.d_out ( dt4_w[3]  )
);

// U4
/*********************************************************/
ynu_ti_xor2     #(4)    U_U4
(
 .d0_in ( yt4_w )
,.d1_in ( dt4_w )
,.d_out ( u4_w  )
);

// UT4
/*********************************************************/
ynu_ti_xor2     U_UT4_0
(
 .d0_in ( u4_w[0]   )
,.d1_in ( u4_w[1]   )
,.d_out ( ut4_w[0]  )
);

ynu_ti_xor2     U_UT4_1
(
 .d0_in ( u4_w[0]   )
,.d1_in ( u4_w[2]   )
,.d_out ( ut4_w[1]  )
);

ynu_ti_xor2     U_UT4_2
(
 .d0_in ( u4_w[1]   )
,.d1_in ( u4_w[3]   )
,.d_out ( ut4_w[2]  )
);

ynu_ti_xor2     U_UT4_3
(
 .d0_in ( u4_w[2]   )
,.d1_in ( u4_w[3]   )
,.d_out ( ut4_w[3]  )
);

ynu_ti_xor2     U_UT4_4
(
 .d0_in ( ut4_w[0]  )
,.d1_in ( ut4_w[3]  )
,.d_out ( ut4_w[4]  )
);

// MX4
/*********************************************************/
ynu_ti_xor3     U_MX4_3
(
 .d0_in ( mx4_w[0]  )
,.d1_in ( mx4_w[2]  )
,.d2_in ( u4_w[3]   )
,.d_out ( mx4_w[3]  )
);

ynu_ti_xor3     U_MX4_4
(
 .d0_in ( mx4_w[0]  )
,.d1_in ( mx4_w[1]  )
,.d2_in ( u4_w[2]   )
,.d_out ( mx4_w[4]  )
);

// MXT4
/*********************************************************/
ynu_ti_xor2     U_MXT4
(
 .d0_in ( mx4_w[3]  )
,.d1_in ( mx4_w[4]  )
,.d_out ( mxt4_w    )
);

// V4
/*********************************************************/
ynu_ti_xor2     U_V4_0
(
 .d0_in ( my4_w[0]  )
,.d1_in ( my4_w[2]  )
,.d_out ( v4_w[0]   )
);

ynu_ti_xor2     U_V4_1
(
 .d0_in ( my4_w[0]  )
,.d1_in ( my4_w[1]  )
,.d_out ( v4_w[1]   )
);

ynu_ti_xor2     U_V4_2
(
 .d0_in ( my4_w[3]  )
,.d1_in ( my4_w[5]  )
,.d_out ( v4_w[2]   )
);

ynu_ti_xor2     U_V4_3
(
 .d0_in ( my4_w[3]  )
,.d1_in ( my4_w[4]  )
,.d_out ( v4_w[3]   )
);

// VA4
/*********************************************************/
assign  va4_w[0] = v4_w[0];

ynu_ti_xor2     U_VA4_1
(
 .d0_in ( v4_w[0]   )
,.d1_in ( v4_w[1]   )
,.d_out ( va4_w[1]  )
);

assign  va4_w[2] = v4_w[1];

ynu_ti_xor2     U_VA4_3
(
 .d0_in ( v4_w[0]   )
,.d1_in ( v4_w[2]   )
,.d_out ( va4_w[3]  )
);

ynu_ti_xor4     U_VA4_4
(
 .d0_in ( v4_w[0]   )
,.d1_in ( v4_w[1]   )
,.d2_in ( v4_w[2]   )
,.d3_in ( v4_w[3]   )
,.d_out ( va4_w[4]  )
);

ynu_ti_xor2     U_VA4_5
(
 .d0_in ( v4_w[1]   )
,.d1_in ( v4_w[3]   )
,.d_out ( va4_w[5]  )
);

assign  va4_w[6] = v4_w[2];

ynu_ti_xor2     U_VA4_6
(
 .d0_in ( v4_w[2]   )
,.d1_in ( v4_w[3]   )
,.d_out ( va4_w[7]  )
);

assign  va4_w[8] = v4_w[3];

// D4
/*********************************************************/
ynu_ti_xor4     U_D4_0
(
 .d0_in ( tp4_w[0]  )
,.d1_in ( tp4_w[2]  )
,.d2_in ( tp4_w[6]  )
,.d3_in ( tp4_w[7]  )
,.d_out ( d4_w[0]   )
);

ynu_ti_xor4     U_D4_1
(
 .d0_in ( tp4_w[0]  )
,.d1_in ( tp4_w[1]  )
,.d2_in ( tp4_w[7]  )
,.d3_in ( tp4_w[8]  )
,.d_out ( d4_w[1]   )
);

ynu_ti_xor4     U_D4_2
(
 .d0_in ( tp4_w[0]  )
,.d1_in ( tp4_w[2]  )
,.d2_in ( tp4_w[3]  )
,.d3_in ( tp4_w[5]  )
,.d_out ( d4_w[2]   )
);

ynu_ti_xor4     U_D4_3
(
 .d0_in ( tp4_w[0]  )
,.d1_in ( tp4_w[1]  )
,.d2_in ( tp4_w[3]  )
,.d3_in ( tp4_w[4]  )
,.d_out ( d4_w[3]   )
);

ynu_ti_xor4     U_D4_4
(
 .d0_in ( tn4_w[0]  )
,.d1_in ( tn4_w[2]  )
,.d2_in ( tn4_w[6]  )
,.d3_in ( tn4_w[7]  )
,.d_out ( d4_w[4]   )
);

ynu_ti_xor4     U_D4_5
(
 .d0_in ( tn4_w[0]  )
,.d1_in ( tn4_w[1]  )
,.d2_in ( tn4_w[7]  )
,.d3_in ( tn4_w[8]  )
,.d_out ( d4_w[5]   )
);

ynu_ti_xor4     U_D4_6
(
 .d0_in ( tn4_w[0]  )
,.d1_in ( tn4_w[2]  )
,.d2_in ( tn4_w[3]  )
,.d3_in ( tn4_w[5]  )
,.d_out ( d4_w[6]   )
);

ynu_ti_xor4     U_D4_7
(
 .d0_in ( tn4_w[0]  )
,.d1_in ( tn4_w[1]  )
,.d2_in ( tn4_w[3]  )
,.d3_in ( tn4_w[4]  )
,.d_out ( d4_w[7]   )
);

assign  d4_out = d4_w;
/*************************************************************************/

// DY
/*********************************************************/
ynu_ti_mulgf2   #(9)    U_DY
(
 .x1_in     ( da1_w     )
,.x2_in     ( da2_w     )
,.x3_in     ( da3_w     )
,.x4_in     ( da4_w     )
,.y1_in     ( dx1_w     )
,.y2_in     ( dx2_w     )
,.y3_in     ( dx3_w     )
,.y4_in     ( dx4_w     )
,.z1_out    ( dy1_w     )
,.z2_out    ( dy2_w     )
,.z3_out    ( dy3_w     )
,.z4_out    ( dy4_w     )
);

// MX
/*********************************************************/
ynu_ti_mulgf2   U_MX0
(
 .x1_in     ( u1_w[0]   )
,.x2_in     ( u2_w[0]   )
,.x3_in     ( u3_w[0]   )
,.x4_in     ( u4_w[0]   )
,.y1_in     ( ut1_w[1]  )
,.y2_in     ( ut2_w[1]  )
,.y3_in     ( ut3_w[1]  )
,.y4_in     ( ut4_w[1]  )
,.z1_out    ( mx1_w[0]  )
,.z2_out    ( mx2_w[0]  )
,.z3_out    ( mx3_w[0]  )
,.z4_out    ( mx4_w[0]  )
);

ynu_ti_mulgf2   U_MX1
(
 .x1_in     ( ut1_w[0]  )
,.x2_in     ( ut2_w[0]  )
,.x3_in     ( ut3_w[0]  )
,.x4_in     ( ut4_w[0]  )
,.y1_in     ( ut1_w[4]  )
,.y2_in     ( ut2_w[4]  )
,.y3_in     ( ut3_w[4]  )
,.y4_in     ( ut4_w[4]  )
,.z1_out    ( mx1_w[1]  )
,.z2_out    ( mx2_w[1]  )
,.z3_out    ( mx3_w[1]  )
,.z4_out    ( mx4_w[1]  )
);

ynu_ti_mulgf2   U_MX2
(
 .x1_in     ( u1_w[1]   )
,.x2_in     ( u2_w[1]   )
,.x3_in     ( u3_w[1]   )
,.x4_in     ( u4_w[1]   )
,.y1_in     ( ut1_w[2]  )
,.y2_in     ( ut2_w[2]  )
,.y3_in     ( ut3_w[2]  )
,.y4_in     ( ut4_w[2]  )
,.z1_out    ( mx1_w[2]  )
,.z2_out    ( mx2_w[2]  )
,.z3_out    ( mx3_w[2]  )
,.z4_out    ( mx4_w[2]  )
);

// MY
/*********************************************************/
ynu_ti_mulgf2   U_MY0
(
 .x1_in     ( mxt1_w    )
,.x2_in     ( mxt2_w    )
,.x3_in     ( mxt3_w    )
,.x4_in     ( mxt4_w    )
,.y1_in     ( ut1_w[1]  )
,.y2_in     ( ut2_w[1]  )
,.y3_in     ( ut3_w[1]  )
,.y4_in     ( ut4_w[1]  )
,.z1_out    ( my1_w[0]  )
,.z2_out    ( my2_w[0]  )
,.z3_out    ( my3_w[0]  )
,.z4_out    ( my4_w[0]  )
);

ynu_ti_mulgf2   U_MY1
(
 .x1_in     ( mx1_w[3]  )
,.x2_in     ( mx2_w[3]  )
,.x3_in     ( mx3_w[3]  )
,.x4_in     ( mx4_w[3]  )
,.y1_in     ( ut1_w[4]  )
,.y2_in     ( ut2_w[4]  )
,.y3_in     ( ut3_w[4]  )
,.y4_in     ( ut4_w[4]  )
,.z1_out    ( my1_w[1]  )
,.z2_out    ( my2_w[1]  )
,.z3_out    ( my3_w[1]  )
,.z4_out    ( my4_w[1]  )
);

ynu_ti_mulgf2   U_MY2
(
 .x1_in     ( mx1_w[4]  )
,.x2_in     ( mx2_w[4]  )
,.x3_in     ( mx3_w[4]  )
,.x4_in     ( mx4_w[4]  )
,.y1_in     ( ut1_w[2]  )
,.y2_in     ( ut2_w[2]  )
,.y3_in     ( ut3_w[2]  )
,.y4_in     ( ut4_w[2]  )
,.z1_out    ( my1_w[2]  )
,.z2_out    ( my2_w[2]  )
,.z3_out    ( my3_w[2]  )
,.z4_out    ( my4_w[2]  )
);

ynu_ti_mulgf2   U_MY3
(
 .x1_in     ( mxt1_w    )
,.x2_in     ( mxt2_w    )
,.x3_in     ( mxt3_w    )
,.x4_in     ( mxt4_w    )
,.y1_in     ( u1_w[2]   )
,.y2_in     ( u2_w[2]   )
,.y3_in     ( u3_w[2]   )
,.y4_in     ( u4_w[2]   )
,.z1_out    ( my1_w[3]  )
,.z2_out    ( my2_w[3]  )
,.z3_out    ( my3_w[3]  )
,.z4_out    ( my4_w[3]  )
);

ynu_ti_mulgf2   U_MY4
(
 .x1_in     ( mx1_w[3]  )
,.x2_in     ( mx2_w[3]  )
,.x3_in     ( mx3_w[3]  )
,.x4_in     ( mx4_w[3]  )
,.y1_in     ( ut1_w[3]  )
,.y2_in     ( ut2_w[3]  )
,.y3_in     ( ut3_w[3]  )
,.y4_in     ( ut4_w[3]  )
,.z1_out    ( my1_w[4]  )
,.z2_out    ( my2_w[4]  )
,.z3_out    ( my3_w[4]  )
,.z4_out    ( my4_w[4]  )
);

ynu_ti_mulgf2   U_MY5
(
 .x1_in     ( mx1_w[4]  )
,.x2_in     ( mx2_w[4]  )
,.x3_in     ( mx3_w[4]  )
,.x4_in     ( mx4_w[4]  )
,.y1_in     ( u1_w[3]   )
,.y2_in     ( u2_w[3]   )
,.y3_in     ( u3_w[3]   )
,.y4_in     ( u4_w[3]   )
,.z1_out    ( my1_w[5]  )
,.z2_out    ( my2_w[5]  )
,.z3_out    ( my3_w[5]  )
,.z4_out    ( my4_w[5]  )
);

// TP, TN
/*********************************************************/
ynu_ti_mulgf2   #(9)    U_TP
(
 .x1_in     ( va1_w     )
,.x2_in     ( va2_w     )
,.x3_in     ( va3_w     )
,.x4_in     ( va4_w     )
,.y1_in     ( dx1_w     )
,.y2_in     ( dx2_w     )
,.y3_in     ( dx3_w     )
,.y4_in     ( dx4_w     )
,.z1_out    ( tp1_w     )
,.z2_out    ( tp2_w     )
,.z3_out    ( tp3_w     )
,.z4_out    ( tp4_w     )
);

ynu_ti_mulgf2   #(9)    U_TN
(
 .x1_in     ( va1_w     )
,.x2_in     ( va2_w     )
,.x3_in     ( va3_w     )
,.x4_in     ( va4_w     )
,.y1_in     ( db1_w     )
,.y2_in     ( db2_w     )
,.y3_in     ( db3_w     )
,.y4_in     ( db4_w     )
,.z1_out    ( tn1_w     )
,.z2_out    ( tn2_w     )
,.z3_out    ( tn3_w     )
,.z4_out    ( tn4_w     )
);


endmodule
