module ynu_ti_mixcolumns
(
 d_in
,d_out
);

input   [31:0]  d_in;
output  [31:0]  d_out;

wire    [7:0]  di0_w,di1_w,di2_w,di3_w;
wire    [7:0]  do0_w,do1_w,do2_w,do3_w;
wire    [7:0]  d0_02_w,d1_02_w,d2_02_w,d3_02_w;
wire    [7:0]  d0_03_w,d1_03_w,d2_03_w,d3_03_w;


assign  {di0_w,di1_w,di2_w,di3_w} = d_in;

ynu_ti_mul02    U_MUL02_0   (.d_in(di0_w), .d_out(d0_02_w));
ynu_ti_mul02    U_MUL02_1   (.d_in(di1_w), .d_out(d1_02_w));
ynu_ti_mul02    U_MUL02_2   (.d_in(di2_w), .d_out(d2_02_w));
ynu_ti_mul02    U_MUL02_3   (.d_in(di3_w), .d_out(d3_02_w));
ynu_ti_mul03    U_MUL03_0   (.d_in(di0_w), .d_out(d0_03_w));
ynu_ti_mul03    U_MUL03_1   (.d_in(di1_w), .d_out(d1_03_w));
ynu_ti_mul03    U_MUL03_2   (.d_in(di2_w), .d_out(d2_03_w));
ynu_ti_mul03    U_MUL03_3   (.d_in(di3_w), .d_out(d3_03_w));

ynu_ti_xor4     #(8)    U_XOR0
(
 .d0_in ( d0_02_w   )
,.d1_in ( d1_03_w   )
,.d2_in ( di2_w     )
,.d3_in ( di3_w     )
,.d_out ( do0_w     )
);

ynu_ti_xor4     #(8)    U_XOR1
(
 .d0_in ( di0_w     )
,.d1_in ( d1_02_w   )
,.d2_in ( d2_03_w   )
,.d3_in ( di3_w     )
,.d_out ( do1_w     )
);

ynu_ti_xor4     #(8)    U_XOR2
(
 .d0_in ( di0_w     )
,.d1_in ( di1_w     )
,.d2_in ( d2_02_w   )
,.d3_in ( d3_03_w   )
,.d_out ( do2_w     )
);

ynu_ti_xor4     #(8)    U_XOR3
(
 .d0_in ( d0_03_w   )
,.d1_in ( di1_w     )
,.d2_in ( di2_w     )
,.d3_in ( d3_02_w   )
,.d_out ( do3_w     )
);


assign  d_out = {do0_w,do1_w,do2_w,do3_w};


endmodule
