module  ynu_ti_mulgf2
(
 x1_in
,x2_in
,x3_in
,x4_in
,y1_in
,y2_in
,y3_in
,y4_in
,z1_out
,z2_out
,z3_out
,z4_out
);

// synopsys template
parameter WIDTH      = 1;

input   [WIDTH-1 : 0]   x1_in;
input   [WIDTH-1 : 0]   x2_in;
input   [WIDTH-1 : 0]   x3_in;
input   [WIDTH-1 : 0]   x4_in;
input   [WIDTH-1 : 0]   y1_in;
input   [WIDTH-1 : 0]   y2_in;
input   [WIDTH-1 : 0]   y3_in;
input   [WIDTH-1 : 0]   y4_in;
output  [WIDTH-1 : 0]   z1_out;
output  [WIDTH-1 : 0]   z2_out;
output  [WIDTH-1 : 0]   z3_out;
output  [WIDTH-1 : 0]   z4_out;

wire    [WIDTH-1 : 0]   tx1_w, tx2_w, tx3_w, tx4_w;
wire    [WIDTH-1 : 0]   ty14_w, ty23_w;
wire    [WIDTH-1 : 0]   txy1_w, txy2_w, txy3_w, txy4_w;


ynu_ti_xor2 #(WIDTH)    U_XOR_TX1
(
 .d0_in ( x3_in )
,.d1_in ( x4_in )
,.d_out ( tx1_w )
);

ynu_ti_xor2 #(WIDTH)    U_XOR_TX2
(
 .d0_in ( x1_in )
,.d1_in ( x3_in )
,.d_out ( tx2_w )
);

ynu_ti_xor2 #(WIDTH)    U_XOR_TX3
(
 .d0_in ( x2_in )
,.d1_in ( x4_in )
,.d_out ( tx3_w )
);

ynu_ti_xor2 #(WIDTH)    U_XOR_TX4
(
 .d0_in ( x1_in )
,.d1_in ( x2_in )
,.d_out ( tx4_w )
);

ynu_ti_xor2 #(WIDTH)    U_XOR_TY14
(
 .d0_in ( y2_in     )
,.d1_in ( y3_in     )
,.d_out ( ty14_w    )
);

ynu_ti_xor2 #(WIDTH)    U_XOR_TY23
(
 .d0_in ( y1_in     )
,.d1_in ( y4_in     )
,.d_out ( ty23_w    )
);

ynu_ti_and2 #(WIDTH)    U_AND_TXY1
(
 .d0_in ( tx1_w     )
,.d1_in ( ty14_w    )
,.d_out ( txy1_w    )
);

ynu_ti_and2 #(WIDTH)    U_AND_TXY2
(
 .d0_in ( tx2_w     )
,.d1_in ( ty23_w    )
,.d_out ( txy2_w    )
);

ynu_ti_and2 #(WIDTH)    U_AND_TXY3
(
 .d0_in ( tx3_w     )
,.d1_in ( ty23_w    )
,.d_out ( txy3_w    )
);

ynu_ti_and2 #(WIDTH)    U_AND_TXY4
(
 .d0_in ( tx4_w     )
,.d1_in ( ty14_w    )
,.d_out ( txy4_w    )
);

ynu_ti_xor7 #(WIDTH)    U_XOR_Z1
(
 .d0_in ( y2_in     )
,.d1_in ( y3_in     )
,.d2_in ( y4_in     )
,.d3_in ( x2_in     )
,.d4_in ( x3_in     )
,.d5_in ( x4_in     )
,.d6_in ( txy1_w    )
,.d_out ( z1_out    )
);

ynu_ti_xor7 #(WIDTH)    U_XOR_Z2
(
 .d0_in ( y1_in     )
,.d1_in ( y3_in     )
,.d2_in ( y4_in     )
,.d3_in ( x1_in     )
,.d4_in ( x3_in     )
,.d5_in ( x4_in     )
,.d6_in ( txy2_w    )
,.d_out ( z2_out    )
);

ynu_ti_xor3 #(WIDTH)    U_XOR_Z3
(
 .d0_in ( y2_in     )
,.d1_in ( x2_in     )
,.d2_in ( txy3_w    )
,.d_out ( z3_out    )
);

ynu_ti_xor3 #(WIDTH)    U_XOR_Z4
(
 .d0_in ( y1_in     )
,.d1_in ( x1_in     )
,.d2_in ( txy4_w    )
,.d_out ( z4_out    )
);


endmodule
