module ynu_ti_subbyte_s4
(
 d1_in
,d2_in
,d3_in
,d4_in
,d1_out
,d2_out
,d3_out
,d4_out
);


input   [7:0]   d1_in;
input   [7:0]   d2_in;
input   [7:0]   d3_in;
input   [7:0]   d4_in;
output  [7:0]   d1_out;
output  [7:0]   d2_out;
output  [7:0]   d3_out;
output  [7:0]   d4_out;

wire    [7:0]   a1_w;
wire    [7:0]   b1_w;
wire    [7:0]   d1_w;
wire    [7:0]   a2_w;
wire    [7:0]   b2_w;
wire    [7:0]   d2_w;
wire    [7:0]   a3_w;
wire    [7:0]   b3_w;
wire    [7:0]   d3_w;
wire    [7:0]   a4_w;
wire    [7:0]   b4_w;
wire    [7:0]   d4_w;

//A1
/************************************************/
ynu_ti_xor3     U_A1_0
(
 .d0_in ( d1_in[0]  )
,.d1_in ( d1_in[1]  )
,.d2_in ( d1_in[6]  )
,.d_out ( a1_w[0]   )
);

ynu_ti_xor3     U_A1_1
(
 .d0_in ( d1_in[1]  )
,.d1_in ( d1_in[4]  )
,.d2_in ( d1_in[6]  )
,.d_out ( a1_w[1]   )
);

ynu_ti_xor5     U_A1_2
(
 .d0_in ( d1_in[1]  )
,.d1_in ( d1_in[2]  )
,.d2_in ( d1_in[3]  )
,.d3_in ( d1_in[4]  )
,.d4_in ( d1_in[7]  )
,.d_out ( a1_w[2]   )
);

ynu_ti_xor4     U_A1_3
(
 .d0_in ( d1_in[1]  )
,.d1_in ( d1_in[2]  )
,.d2_in ( d1_in[6]  )
,.d3_in ( d1_in[7]  )
,.d_out ( a1_w[3]   )
);

ynu_ti_xor5     U_A1_4
(
 .d0_in ( d1_in[1]  )
,.d1_in ( d1_in[2]  )
,.d2_in ( d1_in[3]  )
,.d3_in ( d1_in[5]  )
,.d4_in ( d1_in[7]  )
,.d_out ( a1_w[4]   )
);

ynu_ti_xor4     U_A1_5
(
 .d0_in ( d1_in[2]  )
,.d1_in ( d1_in[3]  )
,.d2_in ( d1_in[5]  )
,.d3_in ( d1_in[7]  )
,.d_out ( a1_w[5]   )
);

ynu_ti_xor6     U_A1_6
(
 .d0_in ( d1_in[1]  )
,.d1_in ( d1_in[2]  )
,.d2_in ( d1_in[3]  )
,.d3_in ( d1_in[4]  )
,.d4_in ( d1_in[6]  )
,.d5_in ( d1_in[7]  )
,.d_out ( a1_w[6]   )
);

ynu_ti_xor2     U_A1_7
(
 .d0_in ( d1_in[5]  )
,.d1_in ( d1_in[7]  )
,.d_out ( a1_w[7]   )
);

//D1
/************************************************/
ynu_ti_xor5     U_D1_0
(
 .d0_in ( b1_w[0]   )
,.d1_in ( b1_w[1]   )
,.d2_in ( b1_w[2]   )
,.d3_in ( b1_w[6]   )
,.d4_in ( b1_w[7]   )
,.d_out ( d1_w[0]   )
);

ynu_ti_xor2     U_D1_1
(
 .d0_in ( b1_w[0]   )
,.d1_in ( b1_w[7]   )
,.d_out ( d1_w[1]   )
);

ynu_ti_xor6     U_D1_2
(
 .d0_in ( b1_w[0]   )
,.d1_in ( b1_w[2]   )
,.d2_in ( b1_w[3]   )
,.d3_in ( b1_w[4]   )
,.d4_in ( b1_w[5]   )
,.d5_in ( b1_w[6]   )
,.d_out ( d1_w[2]   )
);

ynu_ti_xor3     U_D1_3
(
 .d0_in ( b1_w[0]   )
,.d1_in ( b1_w[1]   )
,.d2_in ( b1_w[2]   )
,.d_out ( d1_w[3]   )
);

ynu_ti_xor4     U_D1_4
(
 .d0_in ( b1_w[0]   )
,.d1_in ( b1_w[1]   )
,.d2_in ( b1_w[4]   )
,.d3_in ( b1_w[7]   )
,.d_out ( d1_w[4]   )
);

ynu_ti_xor2     U_D1_5
(
 .d0_in ( b1_w[2]   )
,.d1_in ( b1_w[7]   )
,.d_out ( d1_w[5]   )
);

ynu_ti_xor4     U_D1_6
(
 .d0_in ( b1_w[4]   )
,.d1_in ( b1_w[5]   )
,.d2_in ( b1_w[6]   )
,.d3_in ( b1_w[7]   )
,.d_out ( d1_w[6]   )
);

ynu_ti_xor3     U_D1_7
(
 .d0_in ( b1_w[2]   )
,.d1_in ( b1_w[3]   )
,.d2_in ( b1_w[7]   )
,.d_out ( d1_w[7]   )
);


assign  d1_out = d1_w;


//A2
/************************************************/
ynu_ti_xor3     U_A2_0
(
 .d0_in ( d2_in[0]  )
,.d1_in ( d2_in[1]  )
,.d2_in ( d2_in[6]  )
,.d_out ( a2_w[0]   )
);

ynu_ti_xor3     U_A2_1
(
 .d0_in ( d2_in[1]  )
,.d1_in ( d2_in[4]  )
,.d2_in ( d2_in[6]  )
,.d_out ( a2_w[1]   )
);

ynu_ti_xor5     U_A2_2
(
 .d0_in ( d2_in[1]  )
,.d1_in ( d2_in[2]  )
,.d2_in ( d2_in[3]  )
,.d3_in ( d2_in[4]  )
,.d4_in ( d2_in[7]  )
,.d_out ( a2_w[2]   )
);

ynu_ti_xor4     U_A2_3
(
 .d0_in ( d2_in[1]  )
,.d1_in ( d2_in[2]  )
,.d2_in ( d2_in[6]  )
,.d3_in ( d2_in[7]  )
,.d_out ( a2_w[3]   )
);

ynu_ti_xor5     U_A2_4
(
 .d0_in ( d2_in[1]  )
,.d1_in ( d2_in[2]  )
,.d2_in ( d2_in[3]  )
,.d3_in ( d2_in[5]  )
,.d4_in ( d2_in[7]  )
,.d_out ( a2_w[4]   )
);

ynu_ti_xor4     U_A2_5
(
 .d0_in ( d2_in[2]  )
,.d1_in ( d2_in[3]  )
,.d2_in ( d2_in[5]  )
,.d3_in ( d2_in[7]  )
,.d_out ( a2_w[5]   )
);

ynu_ti_xor6     U_A2_6
(
 .d0_in ( d2_in[1]  )
,.d1_in ( d2_in[2]  )
,.d2_in ( d2_in[3]  )
,.d3_in ( d2_in[4]  )
,.d4_in ( d2_in[6]  )
,.d5_in ( d2_in[7]  )
,.d_out ( a2_w[6]   )
);

ynu_ti_xor2     U_A2_7
(
 .d0_in ( d2_in[5]  )
,.d1_in ( d2_in[7]  )
,.d_out ( a2_w[7]   )
);

//D2
/************************************************/
ynu_ti_xor5     U_D2_0
(
 .d0_in ( b2_w[0]   )
,.d1_in ( b2_w[1]   )
,.d2_in ( b2_w[2]   )
,.d3_in ( b2_w[6]   )
,.d4_in ( b2_w[7]   )
,.d_out ( d2_w[0]   )
);

ynu_ti_xor2     U_D2_1
(
 .d0_in ( b2_w[0]   )
,.d1_in ( b2_w[7]   )
,.d_out ( d2_w[1]   )
);

ynu_ti_xor6     U_D2_2
(
 .d0_in ( b2_w[0]   )
,.d1_in ( b2_w[2]   )
,.d2_in ( b2_w[3]   )
,.d3_in ( b2_w[4]   )
,.d4_in ( b2_w[5]   )
,.d5_in ( b2_w[6]   )
,.d_out ( d2_w[2]   )
);

ynu_ti_xor3     U_D2_3
(
 .d0_in ( b2_w[0]   )
,.d1_in ( b2_w[1]   )
,.d2_in ( b2_w[2]   )
,.d_out ( d2_w[3]   )
);

ynu_ti_xor4     U_D2_4
(
 .d0_in ( b2_w[0]   )
,.d1_in ( b2_w[1]   )
,.d2_in ( b2_w[4]   )
,.d3_in ( b2_w[7]   )
,.d_out ( d2_w[4]   )
);

ynu_ti_xor2     U_D2_5
(
 .d0_in ( b2_w[2]   )
,.d1_in ( b2_w[7]   )
,.d_out ( d2_w[5]   )
);

ynu_ti_xor4     U_D2_6
(
 .d0_in ( b2_w[4]   )
,.d1_in ( b2_w[5]   )
,.d2_in ( b2_w[6]   )
,.d3_in ( b2_w[7]   )
,.d_out ( d2_w[6]   )
);

ynu_ti_xor3     U_D2_7
(
 .d0_in ( b2_w[2]   )
,.d1_in ( b2_w[3]   )
,.d2_in ( b2_w[7]   )
,.d_out ( d2_w[7]   )
);


assign  d2_out = d2_w;

//A3
/************************************************/
ynu_ti_xor3     U_A3_0
(
 .d0_in ( d3_in[0]  )
,.d1_in ( d3_in[1]  )
,.d2_in ( d3_in[6]  )
,.d_out ( a3_w[0]   )
);

ynu_ti_xor3     U_A3_1
(
 .d0_in ( d3_in[1]  )
,.d1_in ( d3_in[4]  )
,.d2_in ( d3_in[6]  )
,.d_out ( a3_w[1]   )
);

ynu_ti_xor5     U_A3_2
(
 .d0_in ( d3_in[1]  )
,.d1_in ( d3_in[2]  )
,.d2_in ( d3_in[3]  )
,.d3_in ( d3_in[4]  )
,.d4_in ( d3_in[7]  )
,.d_out ( a3_w[2]   )
);

ynu_ti_xor4     U_A3_3
(
 .d0_in ( d3_in[1]  )
,.d1_in ( d3_in[2]  )
,.d2_in ( d3_in[6]  )
,.d3_in ( d3_in[7]  )
,.d_out ( a3_w[3]   )
);

ynu_ti_xor5     U_A3_4
(
 .d0_in ( d3_in[1]  )
,.d1_in ( d3_in[2]  )
,.d2_in ( d3_in[3]  )
,.d3_in ( d3_in[5]  )
,.d4_in ( d3_in[7]  )
,.d_out ( a3_w[4]   )
);

ynu_ti_xor4     U_A3_5
(
 .d0_in ( d3_in[2]  )
,.d1_in ( d3_in[3]  )
,.d2_in ( d3_in[5]  )
,.d3_in ( d3_in[7]  )
,.d_out ( a3_w[5]   )
);

ynu_ti_xor6     U_A3_6
(
 .d0_in ( d3_in[1]  )
,.d1_in ( d3_in[2]  )
,.d2_in ( d3_in[3]  )
,.d3_in ( d3_in[4]  )
,.d4_in ( d3_in[6]  )
,.d5_in ( d3_in[7]  )
,.d_out ( a3_w[6]   )
);

ynu_ti_xor2     U_A3_7
(
 .d0_in ( d3_in[5]  )
,.d1_in ( d3_in[7]  )
,.d_out ( a3_w[7]   )
);

//D3
/************************************************/
ynu_ti_xor5     U_D3_0
(
 .d0_in ( b3_w[0]   )
,.d1_in ( b3_w[1]   )
,.d2_in ( b3_w[2]   )
,.d3_in ( b3_w[6]   )
,.d4_in ( b3_w[7]   )
,.d_out ( d3_w[0]   )
);

ynu_ti_xor2     U_D3_1
(
 .d0_in ( b3_w[0]   )
,.d1_in ( b3_w[7]   )
,.d_out ( d3_w[1]   )
);

ynu_ti_xor6     U_D3_2
(
 .d0_in ( b3_w[0]   )
,.d1_in ( b3_w[2]   )
,.d2_in ( b3_w[3]   )
,.d3_in ( b3_w[4]   )
,.d4_in ( b3_w[5]   )
,.d5_in ( b3_w[6]   )
,.d_out ( d3_w[2]   )
);

ynu_ti_xor3     U_D3_3
(
 .d0_in ( b3_w[0]   )
,.d1_in ( b3_w[1]   )
,.d2_in ( b3_w[2]   )
,.d_out ( d3_w[3]   )
);

ynu_ti_xor4     U_D3_4
(
 .d0_in ( b3_w[0]   )
,.d1_in ( b3_w[1]   )
,.d2_in ( b3_w[4]   )
,.d3_in ( b3_w[7]   )
,.d_out ( d3_w[4]   )
);

ynu_ti_xor2     U_D3_5
(
 .d0_in ( b3_w[2]   )
,.d1_in ( b3_w[7]   )
,.d_out ( d3_w[5]   )
);

ynu_ti_xor4     U_D3_6
(
 .d0_in ( b3_w[4]   )
,.d1_in ( b3_w[5]   )
,.d2_in ( b3_w[6]   )
,.d3_in ( b3_w[7]   )
,.d_out ( d3_w[6]   )
);

ynu_ti_xor3     U_D3_7
(
 .d0_in ( b3_w[2]   )
,.d1_in ( b3_w[3]   )
,.d2_in ( b3_w[7]   )
,.d_out ( d3_w[7]   )
);


assign  d3_out = d3_w;

//A4
/************************************************/
ynu_ti_xor3     U_A4_0
(
 .d0_in ( d4_in[0]  )
,.d1_in ( d4_in[1]  )
,.d2_in ( d4_in[6]  )
,.d_out ( a4_w[0]   )
);

ynu_ti_xor3     U_A4_1
(
 .d0_in ( d4_in[1]  )
,.d1_in ( d4_in[4]  )
,.d2_in ( d4_in[6]  )
,.d_out ( a4_w[1]   )
);

ynu_ti_xor5     U_A4_2
(
 .d0_in ( d4_in[1]  )
,.d1_in ( d4_in[2]  )
,.d2_in ( d4_in[3]  )
,.d3_in ( d4_in[4]  )
,.d4_in ( d4_in[7]  )
,.d_out ( a4_w[2]   )
);

ynu_ti_xor4     U_A4_3
(
 .d0_in ( d4_in[1]  )
,.d1_in ( d4_in[2]  )
,.d2_in ( d4_in[6]  )
,.d3_in ( d4_in[7]  )
,.d_out ( a4_w[3]   )
);

ynu_ti_xor5     U_A4_4
(
 .d0_in ( d4_in[1]  )
,.d1_in ( d4_in[2]  )
,.d2_in ( d4_in[3]  )
,.d3_in ( d4_in[5]  )
,.d4_in ( d4_in[7]  )
,.d_out ( a4_w[4]   )
);

ynu_ti_xor4     U_A4_5
(
 .d0_in ( d4_in[2]  )
,.d1_in ( d4_in[3]  )
,.d2_in ( d4_in[5]  )
,.d3_in ( d4_in[7]  )
,.d_out ( a4_w[5]   )
);

ynu_ti_xor6     U_A4_6
(
 .d0_in ( d4_in[1]  )
,.d1_in ( d4_in[2]  )
,.d2_in ( d4_in[3]  )
,.d3_in ( d4_in[4]  )
,.d4_in ( d4_in[6]  )
,.d5_in ( d4_in[7]  )
,.d_out ( a4_w[6]   )
);

ynu_ti_xor2     U_A4_7
(
 .d0_in ( d4_in[5]  )
,.d1_in ( d4_in[7]  )
,.d_out ( a4_w[7]   )
);

//D4
/************************************************/
ynu_ti_xnor5    U_D4_0
(
 .d0_in ( b4_w[0]   )
,.d1_in ( b4_w[1]   )
,.d2_in ( b4_w[2]   )
,.d3_in ( b4_w[6]   )
,.d4_in ( b4_w[7]   )
,.d_out ( d4_w[0]   )
);

ynu_ti_xnor2    U_D4_1
(
 .d0_in ( b4_w[0]   )
,.d1_in ( b4_w[7]   )
,.d_out ( d4_w[1]   )
);

ynu_ti_xor6     U_D4_2
(
 .d0_in ( b4_w[0]   )
,.d1_in ( b4_w[2]   )
,.d2_in ( b4_w[3]   )
,.d3_in ( b4_w[4]   )
,.d4_in ( b4_w[5]   )
,.d5_in ( b4_w[6]   )
,.d_out ( d4_w[2]   )
);

ynu_ti_xor3     U_D4_3
(
 .d0_in ( b4_w[0]   )
,.d1_in ( b4_w[1]   )
,.d2_in ( b4_w[2]   )
,.d_out ( d4_w[3]   )
);

ynu_ti_xor4     U_D4_4
(
 .d0_in ( b4_w[0]   )
,.d1_in ( b4_w[1]   )
,.d2_in ( b4_w[4]   )
,.d3_in ( b4_w[7]   )
,.d_out ( d4_w[4]   )
);

ynu_ti_xnor2    U_D4_5
(
 .d0_in ( b4_w[2]   )
,.d1_in ( b4_w[7]   )
,.d_out ( d4_w[5]   )
);

ynu_ti_xnor4    U_D4_6
(
 .d0_in ( b4_w[4]   )
,.d1_in ( b4_w[5]   )
,.d2_in ( b4_w[6]   )
,.d3_in ( b4_w[7]   )
,.d_out ( d4_w[6]   )
);

ynu_ti_xor3     U_D4_7
(
 .d0_in ( b4_w[2]   )
,.d1_in ( b4_w[3]   )
,.d2_in ( b4_w[7]   )
,.d_out ( d4_w[7]   )
);


assign  d4_out = d4_w;

//B
/************************************************/
ynu_ti_gfinv_s4     U_GFINV
(
 .d1_in     ( a1_w  )
,.d2_in     ( a2_w  )
,.d3_in     ( a3_w  )
,.d4_in     ( a4_w  )
,.d1_out    ( b1_w  )
,.d2_out    ( b2_w  )
,.d3_out    ( b3_w  )
,.d4_out    ( b4_w  )
);


endmodule
