module ynu_ti_subword_s4
(
 d1_in
,d2_in
,d3_in
,d4_in
,d1_out
,d2_out
,d3_out
,d4_out
);


input   [31:0]  d1_in;
input   [31:0]  d2_in;
input   [31:0]  d3_in;
input   [31:0]  d4_in;
output  [31:0]  d1_out;
output  [31:0]  d2_out;
output  [31:0]  d3_out;
output  [31:0]  d4_out;


wire    [7:0]   si10_w,si11_w,si12_w,si13_w;
wire    [7:0]   si20_w,si21_w,si22_w,si23_w;
wire    [7:0]   si30_w,si31_w,si32_w,si33_w;
wire    [7:0]   si40_w,si41_w,si42_w,si43_w;
wire    [7:0]   so10_w,so11_w,so12_w,so13_w;
wire    [7:0]   so20_w,so21_w,so22_w,so23_w;
wire    [7:0]   so30_w,so31_w,so32_w,so33_w;
wire    [7:0]   so40_w,so41_w,so42_w,so43_w;

wire    [31:0]  d1_w;
wire    [31:0]  d2_w;
wire    [31:0]  d3_w;
wire    [31:0]  d4_w;


assign {si10_w,si11_w,si12_w,si13_w} = d1_in;
assign {si20_w,si21_w,si22_w,si23_w} = d2_in;
assign {si30_w,si31_w,si32_w,si33_w} = d3_in;
assign {si40_w,si41_w,si42_w,si43_w} = d4_in;


ynu_ti_subbyte_s4   U_S0
(
 .d1_in     ( si10_w    )
,.d2_in     ( si20_w    )
,.d3_in     ( si30_w    )
,.d4_in     ( si40_w    )
,.d1_out    ( so10_w    )
,.d2_out    ( so20_w    )
,.d3_out    ( so30_w    )
,.d4_out    ( so40_w    )
);

ynu_ti_subbyte_s4   U_S1
(
 .d1_in     ( si11_w    )
,.d2_in     ( si21_w    )
,.d3_in     ( si31_w    )
,.d4_in     ( si41_w    )
,.d1_out    ( so11_w    )
,.d2_out    ( so21_w    )
,.d3_out    ( so31_w    )
,.d4_out    ( so41_w    )
);

ynu_ti_subbyte_s4   U_S2
(
 .d1_in     ( si12_w    )
,.d2_in     ( si22_w    )
,.d3_in     ( si32_w    )
,.d4_in     ( si42_w    )
,.d1_out    ( so12_w    )
,.d2_out    ( so22_w    )
,.d3_out    ( so32_w    )
,.d4_out    ( so42_w    )
);

ynu_ti_subbyte_s4   U_S3
(
 .d1_in     ( si13_w    )
,.d2_in     ( si23_w    )
,.d3_in     ( si33_w    )
,.d4_in     ( si43_w    )
,.d1_out    ( so13_w    )
,.d2_out    ( so23_w    )
,.d3_out    ( so33_w    )
,.d4_out    ( so43_w    )
);

assign d1_w = {so10_w,so11_w,so12_w,so13_w};
assign d2_w = {so20_w,so21_w,so22_w,so23_w};
assign d3_w = {so30_w,so31_w,so32_w,so33_w};
assign d4_w = {so40_w,so41_w,so42_w,so43_w};


assign  d1_out = d1_w;
assign  d2_out = d2_w;
assign  d3_out = d3_w;
assign  d4_out = d4_w;


endmodule
